Index: /trunk/Softwares/Basic_test/src/c/test_setjmp.c
===================================================================
--- /trunk/Softwares/Basic_test/src/c/test_setjmp.c	(revision 88)
+++ /trunk/Softwares/Basic_test/src/c/test_setjmp.c	(revision 88)
@@ -0,0 +1,49 @@
+#include <setjmp.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <math.h>
+jmp_buf env;
+
+int exec_setjmp (int val_max, int base)
+{
+  int res = -2;
+  int val = setjmp(env); // 1 call = 0, first return of longjmp -> 1, après renvoye X^N
+  
+  if (val < val_max)
+    {
+      print(val);
+      res ++;
+      longjmp (env,base*val);
+    }
+  
+  return res;
+}
+
+int test_setjmp  ()
+{
+  quit(exec_setjmp (366,2));
+  
+  return (1);
+  
+  /*
+  int base = 2;
+  int val,res,it;
+  
+  srand(0);
+  
+  for (it = 0; it < 10; it ++)
+    {
+      val = (rand()%1500);
+      
+      res = exec_setjmp (val,base);
+
+      print(res);
+      
+      //printf("test_setjmp : log2(%d)=%d (%d)\n",val,res,(unsigned int)log2((double)val));
+
+      if ((unsigned int)log2(val) != res)
+	return 0;
+    }
+  return 1;
+  */
+}
Index: /trunk/Softwares/Basic_test/src/c/timers_b.c
===================================================================
--- /trunk/Softwares/Basic_test/src/c/timers_b.c	(revision 88)
+++ /trunk/Softwares/Basic_test/src/c/timers_b.c	(revision 88)
@@ -0,0 +1,489 @@
+/*****************************************************/
+/* Various timer routines.                           */
+/* Al Aburto, aburto@nosc.mil, 18 Feb 1997           */
+/*                                                   */
+/* t = dtime() outputs the current time in seconds.  */
+/* Use CAUTION as some of these routines will mess   */
+/* up when timing across the hour mark!!!            */
+/*                                                   */
+/* For timing I use the 'user' time whenever         */
+/* possible. Using 'user+sys' time is a separate     */
+/* issue.                                            */
+/*                                                   */
+/* Example Usage:                                    */
+/* [timer options added here]                        */
+/* main()                                            */
+/* {                                                 */
+/* double starttime,benchtime,dtime();               */
+/*                                                   */
+/* starttime = dtime();                              */ 
+/* [routine to time]                                 */
+/* benchtime = dtime() - starttime;                  */
+/* }                                                 */
+/*                                                   */
+/* [timer code below added here]                     */
+/*****************************************************/
+
+/***************************************************************/
+/* Timer options. You MUST uncomment one of the options below  */
+/* or compile, for example, with the '-DUNIX' option.          */
+/***************************************************************/
+/* #define Amiga       */
+/* #define UNIX        */
+/* #define UNIX_Old    */
+/* #define VMS         */
+/* #define BORLAND_C   */
+/* #define MSC         */
+/* #define MAC         */
+/* #define IPSC        */
+/* #define FORTRAN_SEC */
+/* #define GTODay      */
+/* #define CTimer      */
+/* #define UXPM        */
+/* #define MAC_TMgr    */
+/* #define PARIX       */
+/* #define POSIX       */
+/* #define WIN32       */
+/* #define POSIX1      */
+/***********************/
+
+/*********************************/
+/* Timer code.                   */
+/*********************************/
+
+/***************************************************/
+/*  SIM2OS dtime().                                */
+/***************************************************/
+#ifdef SIM2OS
+
+#include <time.h>
+#include "dhry.h"
+#include "service_clock.h"
+
+#ifndef MHZ
+#define MHZ (1000000)
+#endif //!MHZ
+
+#ifndef FRQ
+#define FRQ (1*MHZ)
+#endif //!FRQ
+
+DOUBLE dtime()
+{
+  DOUBLE         dtime;
+
+  dtime = (DOUBLE)(service_clock())/(DOUBLE)FRQ;
+  
+  return (dtime);
+}
+#endif
+
+/*******************/
+/*  Amiga dtime()  */
+/*******************/
+#ifdef Amiga
+#include <ctype.h>
+#define HZ 50
+
+double dtime()
+{
+ double q;
+
+ struct tt
+       {
+	long  days;
+	long  minutes;
+	long  ticks;
+       } tt;
+
+ DateStamp(&tt);
+
+ q = ((double)(tt.ticks + (tt.minutes * 60L * 50L))) / (double)HZ;
+
+ return q;
+}
+#endif
+
+/*****************************************************/
+/*  UNIX dtime(). This is the preferred UNIX timer.  */
+/*  Provided by: Markku Kolkka, mk59200@cc.tut.fi    */
+/*  HP-UX Addition by: Bo Thide', bt@irfu.se         */
+/*****************************************************/
+#ifdef UNIX
+#include <sys/time.h>
+#include <sys/resource.h>
+
+#ifdef hpux
+#include <sys/syscall.h>
+#define getrusage(a,b) syscall(SYS_getrusage,a,b)
+#endif
+
+struct rusage rusage;
+
+double dtime()
+{
+ double q;
+ getrusage(RUSAGE_SELF,&rusage);
+ q = (double)(rusage.ru_utime.tv_sec);
+ q = q + (double)(rusage.ru_utime.tv_usec) * 1.0e-06;
+ return q;
+}
+#endif
+
+/***************************************************/
+/*  UNIX_Old dtime(). This is the old UNIX timer.  */
+/*  Make sure HZ is properly defined in param.h !! */
+/***************************************************/
+#ifdef UNIX_Old
+#include <sys/types.h>
+#include <sys/times.h>
+#include <sys/param.h>
+
+#ifndef HZ
+#define HZ 60
+#endif
+
+struct tms tms;
+
+double dtime()
+{
+ double q;
+
+ times(&tms);
+
+ q = (double)(tms.tms_utime) / (double)HZ;
+	
+ return q;
+}
+#endif
+
+/*********************************************************/
+/*  VMS dtime() for VMS systems.                         */
+/*  Provided by: RAMO@uvphys.phys.UVic.CA                */
+/*  Some people have run into problems with this timer.  */
+/*********************************************************/
+#ifdef VMS
+#include time
+
+#ifndef HZ
+#define HZ 100
+#endif
+
+struct tbuffer_t
+      {
+       int proc_user_time;
+       int proc_system_time;
+       int child_user_time;
+       int child_system_time;
+      };
+
+struct tbuffer_t tms;
+
+double dtime()
+{
+ double q;
+
+ times(&tms);
+
+ q = (double)(tms.proc_user_time) / (double)HZ;
+	
+ return q;
+}
+#endif
+
+/******************************/
+/*  BORLAND C dtime() for DOS */
+/******************************/
+#ifdef BORLAND_C
+#include <ctype.h>
+#include <dos.h>
+#include <time.h>
+
+#define HZ 100
+struct time tnow;
+
+double dtime()
+{
+ double q;
+
+ gettime(&tnow);
+
+ q = 60.0 * (double)(tnow.ti_min);
+ q = q + (double)(tnow.ti_sec);
+ q = q + (double)(tnow.ti_hund)/(double)HZ;
+	
+ return q;
+}
+#endif
+
+/**************************************/
+/*  Microsoft C (MSC) dtime() for DOS */
+/**************************************/
+#ifdef MSC
+#include <time.h>
+#include <ctype.h>
+
+#define HZ CLOCKS_PER_SEC
+clock_t tnow;
+
+double dtime()
+{
+ double q;
+
+ tnow = clock();
+
+ q = (double)tnow / (double)HZ;
+	
+ return q;
+}
+#endif
+
+/*************************************/
+/*  Macintosh (MAC) Think C dtime()  */
+/*************************************/
+#ifdef MAC
+#include <time.h>
+
+#define HZ 60
+
+double dtime()
+{
+ double q;
+
+ q = (double)clock() / (double)HZ;
+	
+ return q;
+}
+#endif
+
+/************************************************************/
+/*  iPSC/860 (IPSC) dtime() for i860.                       */
+/*  Provided by: Dan Yergeau, yergeau@gloworm.Stanford.EDU  */
+/************************************************************/
+#ifdef IPSC
+extern double dclock();
+
+double dtime()
+{
+ double q;
+
+ q = dclock();
+	
+ return q;
+}
+#endif
+
+/**************************************************/
+/*  FORTRAN dtime() for Cray type systems.        */
+/*  This is the preferred timer for Cray systems. */
+/**************************************************/
+#ifdef FORTRAN_SEC
+
+fortran double second();
+
+double dtime()
+{
+ double q;
+
+ second(&q);
+	
+ return q;
+}
+#endif
+
+/***********************************************************/
+/*  UNICOS C dtime() for Cray UNICOS systems.  Don't use   */
+/*  unless absolutely necessary as returned time includes  */
+/*  'user+system' time.  Provided by: R. Mike Dority,      */
+/*  dority@craysea.cray.com                                */
+/***********************************************************/
+#ifdef CTimer
+#include <time.h>
+
+double dtime()
+{
+ double    q;
+ clock_t   clock(void);
+
+ q = (double)clock() / (double)CLOCKS_PER_SEC;
+
+ return q;
+}
+#endif
+
+/********************************************/
+/* Another UNIX timer using gettimeofday(). */
+/* However, getrusage() is preferred.       */
+/********************************************/
+#ifdef GTODay
+#include <sys/time.h>
+
+struct timeval tnow;
+
+double dtime()
+{
+ double q;
+
+ gettimeofday(&tnow,NULL);
+ q = (double)tnow.tv_sec + (double)tnow.tv_usec * 1.0e-6;
+
+ return q;
+}
+#endif
+
+/*****************************************************/
+/*  Fujitsu UXP/M timer.                             */
+/*  Provided by: Mathew Lim, ANUSF, M.Lim@anu.edu.au */
+/*****************************************************/
+#ifdef UXPM
+#include <sys/types.h>
+#include <sys/timesu.h>
+struct tmsu rusage;
+
+double dtime()
+{
+ double q;
+
+ timesu(&rusage);
+
+ q = (double)(rusage.tms_utime) * 1.0e-06;
+	
+ return q;
+}
+#endif
+
+/**********************************************/
+/*    Macintosh (MAC_TMgr) Think C dtime()    */
+/*   requires Think C Language Extensions or  */
+/*    #include <MacHeaders> in the prefix     */
+/*  provided by Francis H Schiffer 3rd (fhs)  */
+/*         skipschiffer@genie.geis.com        */
+/**********************************************/
+#ifdef MAC_TMgr
+#include <Timer.h>
+#include <stdlib.h>
+
+static TMTask   mgrTimer;
+static Boolean  mgrInited = false;
+static double   mgrClock;
+
+#define RMV_TIMER RmvTime( (QElemPtr)&mgrTimer )
+#define MAX_TIME  1800000000L
+/* MAX_TIME limits time between calls to */
+/* dtime( ) to no more than 30 minutes   */
+/* this limitation could be removed by   */
+/* creating a completion routine to sum  */
+/* 30 minute segments (fhs 1994 feb 9)   */
+
+static void Remove_timer( )
+{
+ RMV_TIMER;
+ mgrInited = false;
+}
+
+double  dtime( )
+{
+ if( mgrInited ) {
+   RMV_TIMER;
+   mgrClock += (MAX_TIME + mgrTimer.tmCount)*1.0e-6;
+ } else {
+   if( _atexit( &Remove_timer ) == 0 ) mgrInited = true;
+   mgrClock = 0.0;
+ }
+ 
+ if ( mgrInited )
+   {
+    mgrTimer.tmAddr = NULL;
+    mgrTimer.tmCount = 0;
+    mgrTimer.tmWakeUp = 0;
+    mgrTimer.tmReserved = 0;
+    InsTime( (QElemPtr)&mgrTimer );
+    PrimeTime( (QElemPtr)&mgrTimer, -MAX_TIME );
+   }
+ return( mgrClock );
+}
+#endif
+
+/***********************************************************/
+/*  Parsytec GCel timer.                                   */
+/*  Provided by: Georg Wambach, gw@informatik.uni-koeln.de */
+/***********************************************************/
+#ifdef PARIX
+#include <sys/time.h>
+
+double dtime()
+{
+ double q;
+
+ q = (double) (TimeNowHigh()) / (double) CLK_TCK_HIGH;
+
+ return q;
+}
+#endif
+
+/************************************************/
+/*  Sun Solaris POSIX dtime() routine           */
+/*  Provided by: Case Larsen, CTLarsen.lbl.gov  */
+/************************************************/
+#ifdef POSIX
+#include <sys/time.h>
+#include <sys/resource.h>
+#include <sys/rusage.h>
+
+#ifdef __hpux
+#include <sys/syscall.h>
+#endif
+
+struct rusage rusage;
+
+double dtime()
+{
+ double q;
+
+ getrusage(RUSAGE_SELF,&rusage);
+
+ q = (double)(rusage.ru_utime.tv_sec);
+ q = q + (double)(rusage.ru_utime.tv_nsec) * 1.0e-09;
+	
+ return q;
+}
+#endif
+
+
+/****************************************************/
+/*  Windows NT (32 bit) dtime() routine             */
+/*  Provided by: Piers Haken, piersh@microsoft.com  */
+/****************************************************/
+#ifdef WIN32
+#include <windows.h>
+
+double dtime(void)
+{
+ double q;
+
+ q = (double)GetTickCount() * 1.0e-03;
+	
+ return q;
+}
+#endif
+
+/*****************************************************/
+/* Time according to POSIX.1  -  <J.Pelan@qub.ac.uk> */
+/* Ref: "POSIX Programmer's Guide"  O'Reilly & Assoc.*/
+/*****************************************************/
+#ifdef POSIX1
+#define _POSIX_SOURCE 1
+#include <unistd.h>
+#include <limits.h>
+#include <sys/times.h>
+
+struct tms tms;
+
+double dtime()
+{
+ double q;
+ times(&tms);
+ q = (double)tms.tms_utime / (double)CLK_TCK;
+ return q;
+}
+#endif
Index: /trunk/Softwares/Global/include/bool.h
===================================================================
--- /trunk/Softwares/Global/include/bool.h	(revision 88)
+++ /trunk/Softwares/Global/include/bool.h	(revision 88)
@@ -0,0 +1,30 @@
+#ifndef BOOL_H
+#define BOOL_H
+
+// typedef enum{false,true} bool;
+
+#ifndef BOOL
+#define BOOL  int
+#endif 
+
+#ifndef bool
+#define bool  int
+#endif 
+
+#ifndef false
+#define false 0
+#endif
+
+#ifndef FALSE
+#define FALSE 0
+#endif
+
+#ifndef TRUE 
+#define TRUE  1
+#endif
+
+#ifndef true 
+#define true  1
+#endif
+
+#endif //!BOOL_H
Index: /trunk/Softwares/Global/include/cpu_info.h
===================================================================
--- /trunk/Softwares/Global/include/cpu_info.h	(revision 88)
+++ /trunk/Softwares/Global/include/cpu_info.h	(revision 88)
@@ -0,0 +1,3 @@
+
+extern unsigned int get_cpu_id();
+extern void         set_cpu_id(unsigned int);
Index: /trunk/Softwares/Global/include/find_one.h
===================================================================
--- /trunk/Softwares/Global/include/find_one.h	(revision 88)
+++ /trunk/Softwares/Global/include/find_one.h	(revision 88)
@@ -0,0 +1,1 @@
+unsigned int  find_first_one (unsigned int val);
Index: /trunk/Softwares/Global/include/func_io.h
===================================================================
--- /trunk/Softwares/Global/include/func_io.h	(revision 88)
+++ /trunk/Softwares/Global/include/func_io.h	(revision 88)
@@ -0,0 +1,4 @@
+#include "mapping_memory.h"
+
+void print(int data);
+void quit (int data);
Index: /trunk/Softwares/Global/include/mapping_memory.h
===================================================================
--- /trunk/Softwares/Global/include/mapping_memory.h	(revision 88)
+++ /trunk/Softwares/Global/include/mapping_memory.h	(revision 88)
@@ -0,0 +1,1 @@
+#include "../../../IPs/systemC/shared/mapping_memory.h"
Index: /trunk/Softwares/Global/include/service_clock.h
===================================================================
--- /trunk/Softwares/Global/include/service_clock.h	(revision 88)
+++ /trunk/Softwares/Global/include/service_clock.h	(revision 88)
@@ -0,0 +1,1 @@
+unsigned int service_clock ();
Index: /trunk/Softwares/Global/include/thread_info.h
===================================================================
--- /trunk/Softwares/Global/include/thread_info.h	(revision 88)
+++ /trunk/Softwares/Global/include/thread_info.h	(revision 88)
@@ -0,0 +1,5 @@
+
+extern unsigned int get_thread_id       ();
+extern void         set_thread_id       (unsigned int);
+extern unsigned int get_thread_priority ();
+extern void         set_thread_priority (unsigned int);
Index: /trunk/Softwares/Global/include/uncached_mask.h
===================================================================
--- /trunk/Softwares/Global/include/uncached_mask.h	(revision 88)
+++ /trunk/Softwares/Global/include/uncached_mask.h	(revision 88)
@@ -0,0 +1,3 @@
+
+extern unsigned int get_uncached_mask       ();
+extern void         set_uncached_mask       (unsigned int);
Index: /trunk/Softwares/Global/ldscript/or32.ld
===================================================================
--- /trunk/Softwares/Global/ldscript/or32.ld	(revision 88)
+++ /trunk/Softwares/Global/ldscript/or32.ld	(revision 88)
@@ -0,0 +1,94 @@
+ENTRY(_start)
+OUTPUT_ARCH(or32)
+/*
+__DYNAMIC  =  0;
+*/
+
+/*
+ * Memory Mapping
+ */
+
+MEMORY
+{
+	iram     : ORIGIN = 0x00000000, LENGTH = 0x01000000
+	dram     : ORIGIN = 0x10000000, LENGTH = 0x10000000
+	dram_unc : ORIGIN = 0x40000000, LENGTH = 0x01000000
+}
+
+/*
+ * Allocate the stack to be at the top of memory, since the stack
+ * grows down.
+ */
+PROVIDE (_stack       = 0x52000000 - 4);
+PROVIDE (__stack      = 0x52000000 - 4);
+PROVIDE (_stack_alloc = 0x00500000    );
+PROVIDE (_tty         = 0xa0000000    );
+
+SECTIONS
+{
+   /*
+    * Code
+    */
+
+   .text : 
+	{
+		*(.text)
+   	} > iram
+
+   /*
+    * Data
+    */
+
+   .rodata : 
+	{
+		*(.rodata);
+		*(.rodata.*);
+	} > dram
+
+   .data : 
+	{
+		sdata   =  .;
+		_sdata  =  .;
+		*(.data)
+		edata   =  .;
+		_edata  =  .;
+	} > dram
+   .bss SIZEOF(.data) + ADDR(.data) :
+	{
+		sbss         = . ;
+		_sbss        = . ;
+		__bss_start  = ALIGN(0x8);
+		___bss_start = ALIGN(0x8);
+		*(.bss)
+		*(COMMON)
+		end          = ALIGN(0x8);
+		_end         = ALIGN(0x8);
+		__end        = ALIGN(0x8);
+		ebss         = .;
+		_ebss        = .;
+	}
+/*
+    .stab  0 (NOLOAD) : 
+        {
+                [ .stab ]
+        }
+        
+    .stabstr  0 (NOLOAD) :
+        {
+                [ .stabstr ]
+        }
+*/
+
+
+   /*
+    * Suppression de la section comment
+    */
+
+   /DISCARD/ :
+	{
+	*(.comment)
+	*(.gnu.*)
+	*(.stab*)
+	}
+}
+
Index: /trunk/Softwares/Global/src/asm/cpu_info.s
===================================================================
--- /trunk/Softwares/Global/src/asm/cpu_info.s	(revision 88)
+++ /trunk/Softwares/Global/src/asm/cpu_info.s	(revision 88)
@@ -0,0 +1,18 @@
+/*
+ * Manipulation of processor information
+ */
+		
+	.file	"cpu_info.s"
+	.section .text
+	.align	4
+
+	.global _get_cpu_id
+_get_cpu_id :
+	l.jr	r9
+	l.mfspr r11,r0,0xF800  /* R11 <- SPR[31][0] */
+
+	.global _set_cpu_id
+_set_cpu_id :
+	l.jr	r9
+	l.mtspr r0 ,r3,0xF800  /* SPR[31][0] <- r3  */
+
Index: /trunk/Softwares/Global/src/asm/find_one.s
===================================================================
--- /trunk/Softwares/Global/src/asm/find_one.s	(revision 88)
+++ /trunk/Softwares/Global/src/asm/find_one.s	(revision 88)
@@ -0,0 +1,19 @@
+/*
+ * Manipulation of bits
+ */
+		
+	.file	"find_one.s"
+	.section .text
+	.align	4
+
+	.global _find_first_one
+_find_first_one :
+	l.jr	r9
+	l.ff1   r11,r3
+
+/*
+	.global _find_last_one
+_find_last_one :
+	l.jr	r9
+	l.fl1   r11,r3,r0
+*/
Index: /trunk/Softwares/Global/src/asm/thread_info.s
===================================================================
--- /trunk/Softwares/Global/src/asm/thread_info.s	(revision 88)
+++ /trunk/Softwares/Global/src/asm/thread_info.s	(revision 88)
@@ -0,0 +1,28 @@
+/*
+ * Manipulation of thread information
+ */
+		
+	.file	"thread_info.s"
+	.section .text
+	.align	4
+
+	.global _get_thread_id
+_get_thread_id :
+	l.jr	r9				
+	l.mfspr r11,r0,0xF801			/* R11 <- SPR[31][1] */
+	
+	.global _set_thread_id
+_set_thread_id :
+	l.jr	r9
+	l.mtspr r0 ,r3,0xF801			/* SPR[31][1] <- r3  */
+
+	.global _get_thread_priority
+_get_thread_priority :
+	l.jr	r9
+	l.mfspr r11,r0,0xF802			/* R11 <- SPR[31][2] */
+
+	.global _set_thread_priority
+_set_thread_priority :
+	l.jr	r9
+	l.mtspr r0 ,r3,0xF802			/* SPR[31][2] <- r3  */
+	
Index: /trunk/Softwares/Global/src/asm/uncached_mask.s
===================================================================
--- /trunk/Softwares/Global/src/asm/uncached_mask.s	(revision 88)
+++ /trunk/Softwares/Global/src/asm/uncached_mask.s	(revision 88)
@@ -0,0 +1,17 @@
+/*
+ * Manipulation of thread information
+ */
+		
+	.file	"uncached_mask.s"
+	.section .text
+	.align	4
+
+	.global _get_uncached_mask
+_get_uncached_mask :
+	l.jr	r9				
+	l.mfspr r11,r0,0xF803			/* R11 <- SPR[31][3] */
+	
+	.global _set_uncached_mask
+_set_uncached_mask :
+	l.jr	r9
+	l.mtspr r0 ,r3,0xF803			/* SPR[31][1] <- r3  */
Index: /trunk/Softwares/Global/src/c/func_io.c
===================================================================
--- /trunk/Softwares/Global/src/c/func_io.c	(revision 88)
+++ /trunk/Softwares/Global/src/c/func_io.c	(revision 88)
@@ -0,0 +1,16 @@
+#include "func_io.h"
+#include "thread_info.h"
+
+void print(int data)
+{
+  int *show   =(int*)(TTY_BASE + (get_thread_id() << 4) + 8);
+
+  *(show) = data;
+}
+
+void quit (int data)
+{
+  int *stop   =(int*)(TTY_BASE + (get_thread_id() << 4) + 4);
+
+  *(stop) = data;
+}
Index: /trunk/Softwares/Global/src/c/service_clock.c
===================================================================
--- /trunk/Softwares/Global/src/c/service_clock.c	(revision 88)
+++ /trunk/Softwares/Global/src/c/service_clock.c	(revision 88)
@@ -0,0 +1,31 @@
+#include <time.h>
+#include <errno.h>
+#include <sys/lock.h>
+#include "mapping_memory.h"
+#include "sim2os.h"
+#include "service_clock.h"
+
+unsigned int service_clock ()
+{
+  unsigned int * addr   = (unsigned int *)(SIM2OS_BASE);
+  unsigned int   result = -1;
+
+  __lock_init    (service_lock);
+  
+  __lock_acquire (service_lock);
+
+  *(addr+0) = (unsigned int)SERVICE_CLOCK;
+ 
+  // memory synchronisation
+  // (else read (with an address that depend not of store address) can be lunch before a store)
+  asm("l.msync;");
+
+  result    = (clock_t) *(addr+1);
+ 
+  if (result == (clock_t)-1)
+    errno = (int) *(addr+2);
+
+  __lock_release (service_lock);
+
+  return result;
+}
Index: /trunk/Softwares/Global/src/sys/crt0.s
===================================================================
--- /trunk/Softwares/Global/src/sys/crt0.s	(revision 88)
+++ /trunk/Softwares/Global/src/sys/crt0.s	(revision 88)
@@ -0,0 +1,1 @@
+link /users/cao/kane/Project/Morpheo/Tools/newlib/libgloss/or32/crt0.S
Index: /trunk/Softwares/Makefile
===================================================================
--- /trunk/Softwares/Makefile	(revision 88)
+++ /trunk/Softwares/Makefile	(revision 88)
@@ -0,0 +1,52 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+ifeq ($(origin MORPHEO_TOPLEVEL), undefined)
+	$(error "variable MORPHEO_TOPLEVEL is undefined")
+else
+	include $(MORPHEO_TOPLEVEL)/Makefile.tools
+endif
+
+#-----[ Variables ]---------------------------------------------------------------
+
+SOFT				= 	Min							\
+					Test/*
+
+#-----[ Rules ]-------------------------------------------------------------------
+
+all 				:
+				@\
+				for i in $(SOFT); do						\
+					$(ECHO) "-------------------| $$i";			\
+					$(MAKE) --directory=$$i --makefile=Makefile;		\
+				done;
+
+clean 				:
+				@\
+				$(RM) *~;							\
+				for i in $(SOFT); do						\
+					$(ECHO) "-------------------| $$i";			\
+					$(MAKE) --directory=$$i --makefile=Makefile clean;	\
+				done;
+
+clean_all                       :
+				@\
+				for i in $(SOFT); do						\
+					$(ECHO) "-------------------| $$i";			\
+					$(MAKE) --directory=$$i --makefile=Makefile clean_all;	\
+				done;
+
+#-----[ Help ]--------------------------------------------------------------------
+help				:
+				@\
+				$(ECHO) "";\
+				$(ECHO) "List of directive   : ";\
+				$(ECHO) " * all              : Compile all softwares";\
+				$(ECHO) " * clean            : Erase all files generates";\
+				$(ECHO) " * clean_all        : Erase all files generates";\
+				$(ECHO) "";
Index: /trunk/Softwares/Makefile.Software
===================================================================
--- /trunk/Softwares/Makefile.Software	(revision 87)
+++ /trunk/Softwares/Makefile.Software	(revision 88)
@@ -1,12 +1,21 @@
-include				$(MORPHEO_TOPLEVEL)/Makefile.tools
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+ifeq ($(origin MORPHEO_TOPLEVEL), undefined)
+	$(error "variable MORPHEO_TOPLEVEL is undefined")
+else
+	include $(MORPHEO_TOPLEVEL)/Makefile.tools
+endif
 
 #-----[ Directory ]---------------------------------------------------------------
-DIRECTORY_OBJ			= obj
-DIRECTORY_BIN			= bin
+DIR_OBJ			        = obj
+DIR_BIN			        = bin
 
 EXE				= soft
-
-#-----[ Files ]-------------------------------------------------------------------
-OBJECTS				= $(OBJECTS_SYS) $(OBJECTS_ASM) $(OBJECTS_C)
 
 #-----[ To the compilation ]------------------------------------------------------
@@ -37,72 +46,58 @@
 # -DHAVE_LIBC
 OR32_AS_OPT			=
-OR32_LD_OPT			= -T$(DIRECTORY_LDSCRIPT)/or32.ld $(LIBRARY)  
+OR32_LD_OPT			= -T$(DIR_LDSCRIPT)/or32.ld $(LIBRARY)  
 OR32_OBJDUMP_OPT		= -D
 OR32_NM_OPT			= -n
 
 #-----[ Rules ]-------------------------------------------------------------------
-.PRECIOUS			: $(DIRECTORY_BIN)/%.x.txt $(DIRECTORY_BIN)/%.x $(DIRECTORY_OBJ)/%.o
+.PRECIOUS			: $(DIR_BIN)/%.x.txt $(DIR_BIN)/%.x $(DIR_OBJ)/%.o
 
-all 				: test_env $(DIRECTORY_BIN)/$(EXE).x.txt
+vpath   %.h     $(DIR_INC)
+vpath   %.c     $(DIR_C)
+vpath   %.s     $(DIR_ASM):$(DIR_SYS)
+vpath   %.o     $(DIR_OBJ)
+vpath   %.x     $(DIR_BIN)
 
-$(DIRECTORY_BIN)/%.x.txt	: $(DIRECTORY_BIN)/%.x
+all 				:
 				@\
-                                $(ECHO) "List symbols       : $*";		\
-				$(OR32_NM)      $(OR32_NM_OPT)      $^ > $@.nm;		\
-				$(ECHO) "Display info       : $*";		\
-				$(OR32_OBJDUMP) $(OR32_OBJDUMP_OPT) $^ > $@;
+				$(MKDIR) $(DIR_BIN) $(DIR_OBJ);                 \
+				$(MAKE)  $(DIR_BIN)/$(EXE).x;
 
-$(DIRECTORY_BIN)/%.x		: $(OBJECTS)
-				@						\
-				$(ECHO) "Linkage            : $*";		\
-				$(OR32_LD) -o $@ $^ $(OR32_LD_OPT);
+$(DIR_BIN)/%.x		        : $(OBJECTS)
+				@\
+				$(ECHO) "Linkage            : $*.x";		\
+				$(OR32_LD) -o $@ $^ $(OR32_LD_OPT);		\
+				$(ECHO) "List symbols       : $*.x.nm";		\
+				$(OR32_NM)      $(OR32_NM_OPT)      $^ > $@.nm;	\
+				$(ECHO) "Display info       : $*.x.txt";		\
+				$(OR32_OBJDUMP) $(OR32_OBJDUMP_OPT) $^ > $@.txt;
 
-$(DIRECTORY_OBJ)/%.o		: $(DIRECTORY_ASM)/%.s	
-				@						\
-                                $(ECHO) "Compilation        : $*";		\
-				$(OR32_CC) $(OR32_CC_OPT)     -o $@   -c $^ ;		\
+$(DIR_OBJ)/%.o		        : %.s	
+				@\
+                                $(ECHO) "Compilation        : $*.s";		\
+				$(OR32_CC) $(OR32_CC_OPT)     -o $@   -c $^ ;	\
 				$(OR32_CC) $(OR32_CC_OPT)  -S -o $@.s -c $^ ;
 #				@$(OR32_AS) $(OR32_AS_OPT) $^ -o $@
 
-$(DIRECTORY_OBJ)/%.o		: $(DIRECTORY_SYS)/%.s	
-				@						\
-                                $(ECHO) "Compilation        : $*";		\
-				$(OR32_CC) $(OR32_CC_OPT)     -o $@   -c $^ ;		\
+$(DIR_OBJ)/%.o			: %.c
+				@\
+                                $(ECHO) "Compilation        : $*.c";		\
+				$(OR32_CC) $(OR32_CC_OPT)     -o $@   -c $^ ;	\
 				$(OR32_CC) $(OR32_CC_OPT)  -S -o $@.s -c $^ ;
-#				@$(OR32_AS) $(OR32_AS_OPT) $^ -o $@
-
-$(DIRECTORY_OBJ)/%.o		: $(DIRECTORY_C)/%.c
-				@						\
-                                $(ECHO) "Compilation        : $*";		\
-				$(OR32_CC) $(OR32_CC_OPT)     -o $@   -c $^ ;		\
-				$(OR32_CC) $(OR32_CC_OPT)  -S -o $@.s -c $^ ;
-
-#-----[ Environement ]------------------------------------------------------------
-test_env			:
-# ifeq ($(origin TOOLS), undefined)
-#				$(error "variable TOOLS is undefined");
-# endif
-# ifeq ($(origin SOFT), undefined)
-#				$(error "variable SOFT  is undefined");
-# endif
-				@$(MKDIR) $(DIRECTORY_OBJ) $(DIRECTORY_BIN)
 
 #-----[ Maintenance ]-------------------------------------------------------------
 clean 				:
 				@\
-				$(ECHO) "Delete     temporary files              "`$(PWD)`;		\
-				$(RM) $(DIRECTORY_OBJ) $(DIRECTORY_BIN);						\
-				$(MAKE) clean_rec DIRECTORY_CLEAN=.;
+				$(ECHO) "Delete     temporary files";		\
+				$(RM)   $(DIR_OBJ) $(DIR_BIN)	\
+					*~		        \
+					$(DIR_SRC)/*~	        \
+					$(DIR_C)/*~	        \
+					$(DIR_ASM)/*~	        \
+					$(DIR_SYS)/*~	        \
+					$(DIR_INC)/*~	        \
+					$(DIR_LDSCRIPT)/*~      \
 
-clean_rec			:
-				@\
-				$(ECHO) "Delete     temporary files in directory $(DIRECTORY_CLEAN)";		\
-				$(RM) -f $(DIRECTORY_CLEAN)/*~;						\
-				for files in `$(LS) $(DIRECTORY_CLEAN)`; do					\
-				    	if $(TEST) -d $(DIRECTORY_CLEAN)/$$files; 				\
-					then 								\
-						$(MAKE) clean_rec DIRECTORY_CLEAN=$(DIRECTORY_CLEAN)/$$files;	\
-					fi; 								\
-				done;
+clean_all                       : clean
 
 #-----[ Help ]--------------------------------------------------------------------
@@ -111,5 +106,6 @@
 				$(ECHO) "";\
 				$(ECHO) "List of directive   : ";\
-				$(ECHO) " * make             : Compile the software";\
-				$(ECHO) " * make clean       : Erase all files generates";\
+				$(ECHO) " * all              : Compile the software";\
+				$(ECHO) " * clean            : Erase all files generates";\
+				$(ECHO) " * clean_all        : Erase all files generates";\
 				$(ECHO) "";
Index: /trunk/Softwares/Min/Makefile
===================================================================
--- /trunk/Softwares/Min/Makefile	(revision 88)
+++ /trunk/Softwares/Min/Makefile	(revision 88)
@@ -0,0 +1,26 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+# common definition
+DIR_SRC				= ./src
+DIR_C				= $(DIR_SRC)/c
+DIR_ASM				= $(DIR_SRC)/asm
+DIR_SYS				= $(DIR_SRC)/sys
+DIR_INC		       		= $(DIR_C)/include
+DIR_LDSCRIPT			= ../Global/ldscript/
+
+INCLUDE				= -I$(DIR_INC)
+LIBRARY				= 
+
+#-----[ Files ]-------------------------------------------------------------------
+OBJECTS				= 	$(patsubst $(DIR_ASM)/%.s,$(DIR_OBJ)/%.o,$(wildcard $(DIR_ASM)/*.s))	\
+					$(patsubst $(DIR_SYS)/%.s,$(DIR_OBJ)/%.o,$(wildcard $(DIR_SYS)/*.s))	\
+					$(patsubst $(DIR_C)/%.c,$(DIR_OBJ)/%.o,$(wildcard $(DIR_C)/*.c))
+
+include				../Makefile.Software
+
Index: /trunk/Softwares/Min/src/asm/cpu_info.s
===================================================================
--- /trunk/Softwares/Min/src/asm/cpu_info.s	(revision 88)
+++ /trunk/Softwares/Min/src/asm/cpu_info.s	(revision 88)
@@ -0,0 +1,18 @@
+/*
+ * Manipulation of processor information
+ */
+		
+	.file	"cpu_info.s"
+	.section .text
+	.align	4
+
+	.global _get_cpu_id
+_get_cpu_id :
+	l.jr	r9
+	l.mfspr r11,r0,0xF800  /* R11 <- SPR[31][0] */
+
+	.global _set_cpu_id
+_set_cpu_id :
+	l.jr	r9
+	l.mtspr r0 ,r3,0xF800  /* SPR[31][0] <- r3  */
+
Index: /trunk/Softwares/Min/src/asm/find_one.s
===================================================================
--- /trunk/Softwares/Min/src/asm/find_one.s	(revision 88)
+++ /trunk/Softwares/Min/src/asm/find_one.s	(revision 88)
@@ -0,0 +1,19 @@
+/*
+ * Manipulation of bits
+ */
+		
+	.file	"find_one.s"
+	.section .text
+	.align	4
+
+	.global _find_first_one
+_find_first_one :
+	l.jr	r9
+	l.ff1   r11,r3
+
+/*
+	.global _find_last_one
+_find_last_one :
+	l.jr	r9
+	l.fl1   r11,r3,r0
+*/
Index: /trunk/Softwares/Min/src/asm/thread_info.s
===================================================================
--- /trunk/Softwares/Min/src/asm/thread_info.s	(revision 88)
+++ /trunk/Softwares/Min/src/asm/thread_info.s	(revision 88)
@@ -0,0 +1,28 @@
+/*
+ * Manipulation of thread information
+ */
+		
+	.file	"thread_info.s"
+	.section .text
+	.align	4
+
+	.global _get_thread_id
+_get_thread_id :
+	l.jr	r9				
+	l.mfspr r11,r0,0xF801			/* R11 <- SPR[31][1] */
+	
+	.global _set_thread_id
+_set_thread_id :
+	l.jr	r9
+	l.mtspr r0 ,r3,0xF801			/* SPR[31][1] <- r3  */
+
+	.global _get_thread_priority
+_get_thread_priority :
+	l.jr	r9
+	l.mfspr r11,r0,0xF802			/* R11 <- SPR[31][2] */
+
+	.global _set_thread_priority
+_set_thread_priority :
+	l.jr	r9
+	l.mtspr r0 ,r3,0xF802			/* SPR[31][2] <- r3  */
+	
Index: /trunk/Softwares/Min/src/c/include/cpu_info.h
===================================================================
--- /trunk/Softwares/Min/src/c/include/cpu_info.h	(revision 88)
+++ /trunk/Softwares/Min/src/c/include/cpu_info.h	(revision 88)
@@ -0,0 +1,3 @@
+
+extern unsigned int get_cpu_id();
+extern void         set_cpu_id(unsigned int);
